
#ifndef CALC_PEAK_H_included
#define CALC_PEAK_H_included

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//*******************************************************************************


class PeakTrackObj
{
protected:

  double T1, T2;

public:

 double *pointer;
 double peak, peakStored[2];
 bool   startFlag, startFlagStored[2];
 double *tptr;
 char   *ID;
 char   *varName;
 int    varPos; //char   MinMax[4];
 bool   isMax; // true if tracking a maximum; false if tracking a minimum

 /*
 PeakTrackObj() { ID = 0; }

 const PeakTrackObj& operator=(const PeakTrackObj &PO) {
   peak = old_peak = -1.0; flag = false; Time = 0.0;
   pointer = PO.pointer; T1 = PO.T1; T2 = PO.T2;
   }
 */
    
 void set_pointer(TokenString &Param, class VarList *VL);

 PeakTrackObj(TokenString &Param, const char *minmax, int i);

 ~PeakTrackObj() { delete [] ID; delete [] varName; }

 double Evaluate();

 void saveState(int level = 0) { peakStored[level] = peak; startFlagStored[level] = startFlag; }
 void recoverState(int level = 0) { peak = peakStored[level]; startFlag = startFlagStored[level]; }
};

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//*******************************************************************************

class PeakTrackArray
{
 public:

  PeakTrackObj **array;
  int          peak_num;

  PeakTrackArray()  { array = 0; peak_num = 0; }

  PeakTrackArray(TokenString &);

  void set_pointers(TokenString &TS, class VarList *VL);

  /*
  const PeakTrackArray& operator=(const PeakTrackArray& PTA)  {
    if (&PTA != this) { delete [] array; copy(PTA); }
    return *this;
  }

  void copy(const PeakTrackArray &);
  */

  ~PeakTrackArray()  { for (int i=0; i<peak_num; i++) delete array[i];
                       if (peak_num) delete [] array; }  

  void Evaluate()  {
    for (int i = 0; i < peak_num; i++) array[i]->Evaluate();
  }

  void saveState(int level = 0) { for (int i = 0; i < peak_num; i++) array[i]->saveState(level); }
  void recoverState(int level = 0) { for (int i = 0; i < peak_num; i++) array[i]->recoverState(level); }
};

//**************************************************************************

#endif
